/**
      SoS (Sense Of Self) // Sending and Reading Sensor's data to Dweet // TeZ 2017
      //  http://dweet.io/
 */

#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#define USE_SERIAL Serial

ESP8266WiFiMulti WiFiMulti;
HTTPClient myhttp;

String dweeter = "http://dweet.io/dweet/for/heartbeat?myvalue=";
float prog = 0;




///////////////////////////////////////////////////
void setup() {

    USE_SERIAL.begin(115200);
   // USE_SERIAL.setDebugOutput(true);

    USE_SERIAL.println();
    USE_SERIAL.println();
    USE_SERIAL.println();

    for(uint8_t t = 4; t > 0; t--) {
        USE_SERIAL.printf("[SETUP] WAIT %d...\n", t);
        USE_SERIAL.flush();
        delay(1000);
    }

    delay(1000);

    // WiFiMulti.addAP("SSID", "PASSWORD");
    WiFiMulti.addAP("Homelezz", "kristez234");
 


 // wait for WiFi connection
     USE_SERIAL.print("Connecting to local WiFi ");
    while((WiFiMulti.run() != WL_CONNECTED)) {
        USE_SERIAL.print(".");
    }

    // dweeter.concat("X"); // test concat
  
    USE_SERIAL.println();
    USE_SERIAL.println("YEAH!!  Connected to local WiFi ");
    USE_SERIAL.println();

    delay (1000);
    PostDweet("heartbeat", 123); // first call and init to the http socket
    delay (3000);
}


///////////////////////////////////////////////////
  void PostDweet(String mysensor, float myvalue){

        dweeter = "http://dweet.io/dweet/for/";//
        dweeter.concat(mysensor); 
        dweeter.concat("?myvalue="); 
        dweeter.concat(myvalue); // attach the variable (here you change the parameter with your variable)
        myhttp.begin(dweeter); // here connects and POSTs data to DWEET at the same time
        USE_SERIAL.print("POSTed >> "); 
        // USE_SERIAL.println(dweeter);


          // GET SESSION
        // start connection and send HTTP header
        int httpCode = myhttp.GET();
 
        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
            USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                String payload = myhttp.getString();
                USE_SERIAL.println(payload);
            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", myhttp.errorToString(httpCode).c_str());
        }

      // END GET SESSION

        //GetDweet(mysensor);
        
        myhttp.end();


/*
        dweeter = "http://dweet.io/dweet/for/heartbeat?myvalue="; // this is fixed, DO NOT CHANGE
        prog +=1; // this is the variable to be attached to the Dweet Post, can be your sensor value
        dweeter.concat(prog); // attach the variable (here you change the parameter with your variable)
        posthttp.begin(dweeter); // here connects and POSTs data to DWEET at the same time
        USE_SERIAL.print("POSTed >> "); 
        USE_SERIAL.println(dweeter);
  */

}



///////////////////////////////////////////////////
void GetDweet(String mysensor){

    //   posthttp.begin("http://dweet.io/get/latest/dweet/for/tez-sensor-02"); // here connects to GET DWEET data

          String sensorUrl = "http://dweet.io/get/latest/dweet/for/";
          sensorUrl.concat(mysensor);
       
          myhttp.begin(sensorUrl); // here connects to GET DWEET data
 
        // start connection and send HTTP header
        int httpCode = myhttp.GET();
 
        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
            USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                String payload = myhttp.getString();
                USE_SERIAL.println(payload);
            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", myhttp.errorToString(httpCode).c_str());
        }

       myhttp.end();

}




///////////////////////////////////////////////////
void loop() {
    
/*
        PostDweet(); // Use this to POST data from your sensor(s)

        delay(2000);

        GetDweet(); // Use this to GET data from DWEET
        
        delay(2000);

*/
  
   //  PostDweet("heartbeatez", 999.66);
       delay(2000);
       GetDweet("heartbeat");
       delay(2000);
       

}

